diff --git a/gcc/tracer.c b/gcc/tracer.c
index f036c19..eca631a 100644
--- a/gcc/tracer.c
+++ b/gcc/tracer.c
@@ -247,7 +247,7 @@ tail_duplicate (void)
   bitmap_clear (bb_seen);
   initialize_original_copy_tables ();
 
-  if (profile_info && flag_branch_probabilities)
+  if (profile_info && GCC_OPTION (flag_branch_probabilities))
     probability_cutoff = PARAM_VALUE (TRACER_MIN_BRANCH_PROBABILITY_FEEDBACK);
   else
     probability_cutoff = PARAM_VALUE (TRACER_MIN_BRANCH_PROBABILITY);
@@ -268,7 +268,7 @@ tail_duplicate (void)
       weighted_insns += n * bb->frequency;
     }
 
-  if (profile_info && flag_branch_probabilities)
+  if (profile_info && GCC_OPTION (flag_branch_probabilities))
     cover_insns = PARAM_VALUE (TRACER_DYNAMIC_COVERAGE_FEEDBACK);
   else
     cover_insns = PARAM_VALUE (TRACER_DYNAMIC_COVERAGE);
@@ -401,7 +401,7 @@ tracer (void)
 static bool
 gate_tracer (void)
 {
-  return (optimize > 0 && flag_tracer && flag_reorder_blocks);
+  return (GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_tracer) && GCC_OPTION (flag_reorder_blocks));
 }
 
 namespace {
diff --git a/gcc/trans-mem.c b/gcc/trans-mem.c
index fe6dc28..22e0472 100644
--- a/gcc/trans-mem.c
+++ b/gcc/trans-mem.c
@@ -250,7 +250,7 @@ is_tm_irrevocable (tree x)
 bool
 is_tm_safe (const_tree x)
 {
-  if (flag_tm)
+  if (GCC_OPTION (flag_tm))
     {
       tree attrs = get_attrs_for (x);
       if (attrs)
@@ -462,7 +462,7 @@ build_tm_abort_call (location_t loc, bool is_outer)
 static bool
 gate_tm (void)
 {
-  return flag_tm;
+  return GCC_OPTION (flag_tm);
 }
 
 /* Map for aribtrary function replacement under TM, as created
@@ -1639,7 +1639,7 @@ lower_transaction (gimple_stmt_iterator *gsi, struct walk_stmt_info *wi)
   /* Wrap the body of the transaction in a try-finally node so that
      the commit call is always properly called.  */
   g = gimple_build_call (builtin_decl_explicit (BUILT_IN_TM_COMMIT), 0);
-  if (flag_exceptions)
+  if (GCC_OPTION (flag_exceptions))
     {
       tree ptr;
       gimple_seq n_seq, e_seq;
@@ -2004,7 +2004,7 @@ tm_region_init (struct tm_region *region)
 static bool
 gate_tm_init (void)
 {
-  if (!flag_tm)
+  if (!GCC_OPTION (flag_tm))
     return false;
 
   calculate_dominance_info (CDI_DOMINATORS);
@@ -3937,7 +3937,7 @@ execute_tm_memopt (void)
 static bool
 gate_tm_memopt (void)
 {
-  return flag_tm && optimize > 0;
+  return GCC_OPTION (flag_tm) && GCC_OPTION (optimize) > 0;
 }
 
 namespace {
diff --git a/gcc/tree-call-cdce.c b/gcc/tree-call-cdce.c
index 4b2ad87..2337af0 100644
--- a/gcc/tree-call-cdce.c
+++ b/gcc/tree-call-cdce.c
@@ -923,7 +923,7 @@ gate_call_cdce (void)
   /* The limit constants used in the implementation
      assume IEEE floating point format.  Other formats
      can be supported in the future if needed.  */
-  return flag_tree_builtin_call_dce != 0 && optimize_function_for_speed_p (cfun);
+  return GCC_OPTION (flag_tree_builtin_call_dce) != 0 && optimize_function_for_speed_p (cfun);
 }
 
 namespace {
diff --git a/gcc/tree-cfg.c b/gcc/tree-cfg.c
index 56b6c35..8a051fc 100644
--- a/gcc/tree-cfg.c
+++ b/gcc/tree-cfg.c
@@ -1626,7 +1626,7 @@ gimple_can_merge_blocks_p (basic_block a, basic_block b)
       lab = gimple_label_label (stmt);
 
       /* Do not remove user forced labels or for -O0 any user labels.  */
-      if (!DECL_ARTIFICIAL (lab) && (!optimize || FORCED_LABEL (lab)))
+      if (!DECL_ARTIFICIAL (lab) && (!GCC_OPTION (optimize) || FORCED_LABEL (lab)))
 	return false;
     }
 
@@ -1646,7 +1646,7 @@ gimple_can_merge_blocks_p (basic_block a, basic_block b)
     }
 
   /* When not optimizing, don't merge if we'd lose goto_locus.  */
-  if (!optimize
+  if (!GCC_OPTION (optimize)
       && single_succ_edge (a)->goto_locus != UNKNOWN_LOCATION)
     {
       location_t goto_locus = single_succ_edge (a)->goto_locus;
@@ -4007,7 +4007,7 @@ verify_gimple_assign_single (gimple stmt)
 	   gimple hygiene asks for this check.  In LTO we can end up
 	   combining incompatible units and thus end up with addresses
 	   of globals that change their type to a common one.  */
-	if (!in_lto_p
+	if (!GCC_OPTION (in_lto_p)
 	    && !types_compatible_p (TREE_TYPE (op),
 				    TREE_TYPE (TREE_TYPE (rhs1)))
 	    && !one_pointer_to_useless_type_conversion_p (TREE_TYPE (rhs1),
@@ -8188,7 +8188,7 @@ execute_warn_function_return (void)
 
   /* If we see "return;" in some basic block, then we do reach the end
      without returning a value.  */
-  else if (warn_return_type
+  else if (GCC_OPTION (warn_return_type)
 	   && !TREE_NO_WARNING (cfun->decl)
 	   && EDGE_COUNT (EXIT_BLOCK_PTR_FOR_FN (cfun)->preds) > 0
 	   && !VOID_TYPE_P (TREE_TYPE (TREE_TYPE (cfun->decl))))
@@ -8349,7 +8349,7 @@ run_warn_unused_result (void)
 static bool
 gate_warn_unused_result (void)
 {
-  return flag_warn_unused_result;
+  return GCC_OPTION (flag_warn_unused_result);
 }
 
 namespace {
diff --git a/gcc/tree-cfgcleanup.c b/gcc/tree-cfgcleanup.c
index 08401dd..55bfd36 100644
--- a/gcc/tree-cfgcleanup.c
+++ b/gcc/tree-cfgcleanup.c
@@ -276,7 +276,7 @@ tree_forwarder_block_p (basic_block bb, bool phi_wanted)
 	return false;
       /* If goto_locus of any of the edges differs, prevent removing
 	 the forwarder block for -O0.  */
-      else if (optimize == 0 && e->goto_locus != locus)
+      else if (GCC_OPTION (optimize) == 0 && e->goto_locus != locus)
 	return false;
   }
 
@@ -291,7 +291,7 @@ tree_forwarder_block_p (basic_block bb, bool phi_wanted)
 	case GIMPLE_LABEL:
 	  if (DECL_NONLOCAL (gimple_label_label (stmt)))
 	    return false;
-	  if (optimize == 0 && gimple_location (stmt) != locus)
+	  if (GCC_OPTION (optimize) == 0 && gimple_location (stmt) != locus)
 	    return false;
 	  break;
 
@@ -1097,32 +1097,32 @@ execute_cleanup_cfg_post_optimizing (void)
   maybe_remove_unreachable_handlers ();
   cleanup_dead_labels ();
   group_case_labels ();
-  if ((flag_compare_debug_opt || flag_compare_debug)
-      && flag_dump_final_insns)
+  if ((GCC_OPTION (flag_compare_debug_opt) || GCC_OPTION (flag_compare_debug))
+      && GCC_OPTION (flag_dump_final_insns))
     {
-      FILE *final_output = fopen (flag_dump_final_insns, "a");
+      FILE *final_output = fopen (GCC_OPTION (flag_dump_final_insns), "a");
 
       if (!final_output)
 	{
 	  error ("could not open final insn dump file %qs: %m",
-		 flag_dump_final_insns);
-	  flag_dump_final_insns = NULL;
+		 GCC_OPTION (flag_dump_final_insns));
+	  GCC_OPTION (flag_dump_final_insns) = NULL;
 	}
       else
 	{
-	  int save_unnumbered = flag_dump_unnumbered;
-	  int save_noaddr = flag_dump_noaddr;
+	  int save_unnumbered = GCC_OPTION (flag_dump_unnumbered);
+	  int save_noaddr = GCC_OPTION (flag_dump_noaddr);
 
-	  flag_dump_noaddr = flag_dump_unnumbered = 1;
+	  GCC_OPTION (flag_dump_noaddr) = GCC_OPTION (flag_dump_unnumbered) = 1;
 	  fprintf (final_output, "\n");
 	  dump_enumerated_decls (final_output, dump_flags | TDF_NOUID);
-	  flag_dump_noaddr = save_noaddr;
-	  flag_dump_unnumbered = save_unnumbered;
+	  GCC_OPTION (flag_dump_noaddr) = save_noaddr;
+	  GCC_OPTION (flag_dump_unnumbered) = save_unnumbered;
 	  if (fclose (final_output))
 	    {
 	      error ("could not close final insn dump file %qs: %m",
-		     flag_dump_final_insns);
-	      flag_dump_final_insns = NULL;
+		     GCC_OPTION (flag_dump_final_insns));
+	      GCC_OPTION (flag_dump_final_insns) = NULL;
 	    }
 	}
     }
diff --git a/gcc/tree-complex.c b/gcc/tree-complex.c
index 4a657c0..29462a6 100644
--- a/gcc/tree-complex.c
+++ b/gcc/tree-complex.c
@@ -115,7 +115,7 @@ some_nonzerop (tree t)
   /* Operations with real or imaginary part of a complex number zero
      cannot be treated the same as operations with a real or imaginary
      operand if we care about the signs of zeros in the result.  */
-  if (TREE_CODE (t) == REAL_CST && !flag_signed_zeros)
+  if (TREE_CODE (t) == REAL_CST && !GCC_OPTION (flag_signed_zeros))
     zerop = REAL_VALUES_IDENTICAL (TREE_REAL_CST (t), dconst0);
   else if (TREE_CODE (t) == FIXED_CST)
     zerop = fixed_zerop (t);
@@ -1038,7 +1038,7 @@ expand_complex_multiplication (gimple_stmt_iterator *gsi, tree inner_type,
       break;
 
     case PAIR (VARYING, VARYING):
-      if (flag_complex_method == 2 && SCALAR_FLOAT_TYPE_P (inner_type))
+      if (GCC_OPTION (flag_complex_method) == 2 && SCALAR_FLOAT_TYPE_P (inner_type))
 	{
 	  expand_complex_libcall (gsi, ar, ai, br, bi, MULT_EXPR);
 	  return;
@@ -1308,7 +1308,7 @@ expand_complex_division (gimple_stmt_iterator *gsi, tree inner_type,
     case PAIR (ONLY_REAL, VARYING):
     case PAIR (ONLY_IMAG, VARYING):
     case PAIR (VARYING, VARYING):
-      switch (flag_complex_method)
+      switch (GCC_OPTION (flag_complex_method))
 	{
 	case 0:
 	  /* straightforward implementation of complex divide acceptable.  */
diff --git a/gcc/tree-data-ref.c b/gcc/tree-data-ref.c
index 01d0a7a..bb43068 100644
--- a/gcc/tree-data-ref.c
+++ b/gcc/tree-data-ref.c
@@ -4195,7 +4195,7 @@ compute_affine_dependence (struct data_dependence_relation *ddr,
 	{
 	  subscript_dependence_tester (ddr, loop_nest);
 
-	  if (flag_check_data_deps)
+	  if (GCC_OPTION (flag_check_data_deps))
 	    {
 	      /* Dump the dependences from the first algorithm.  */
 	      if (dump_file && (dump_flags & TDF_DETAILS))
diff --git a/gcc/tree-eh.c b/gcc/tree-eh.c
index 14ed52a..551437b 100644
--- a/gcc/tree-eh.c
+++ b/gcc/tree-eh.c
@@ -1593,7 +1593,7 @@ decide_copy_try_finally (int ndests, bool may_throw, gimple_seq finally)
       finally = gimple_eh_else_n_body (eh_else);
     }
 
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     {
       gimple_stmt_iterator gsi;
 
@@ -1621,7 +1621,7 @@ decide_copy_try_finally (int ndests, bool may_throw, gimple_seq finally)
     return f_estimate < sw_estimate;
 
   /* ??? These numbers are completely made up so far.  */
-  if (optimize > 1)
+  if (GCC_OPTION (optimize) > 1)
     return f_estimate < 100 || f_estimate < sw_estimate * 2;
   else
     return f_estimate < 40 || f_estimate * 2 < sw_estimate * 3;
@@ -1765,7 +1765,7 @@ lower_catch (struct leh_state *state, gimple tp)
   gimple x;
   location_t try_catch_loc = gimple_location (tp);
 
-  if (flag_exceptions)
+  if (GCC_OPTION (flag_exceptions))
     {
       try_region = gen_eh_region_try (state->cur_region);
       this_state.cur_region = try_region;
@@ -1836,7 +1836,7 @@ lower_eh_filter (struct leh_state *state, gimple tp)
 
   inner = gimple_seq_first_stmt (gimple_try_cleanup (tp));
 
-  if (flag_exceptions)
+  if (GCC_OPTION (flag_exceptions))
     {
       this_region = gen_eh_region_allowed (state->cur_region,
 				           gimple_eh_filter_types (inner));
@@ -1876,7 +1876,7 @@ lower_eh_must_not_throw (struct leh_state *state, gimple tp)
 {
   struct leh_state this_state = *state;
 
-  if (flag_exceptions)
+  if (GCC_OPTION (flag_exceptions))
     {
       gimple inner = gimple_seq_first_stmt (gimple_try_cleanup (tp));
       eh_region this_region;
@@ -1912,7 +1912,7 @@ lower_cleanup (struct leh_state *state, gimple tp)
   gimple_seq result;
   bool cleanup_dead = cleanup_is_dead_in (state->cur_region);
 
-  if (flag_exceptions && !cleanup_dead)
+  if (GCC_OPTION (flag_exceptions) && !cleanup_dead)
     {
       this_region = gen_eh_region_cleanup (state->cur_region);
       this_state.cur_region = this_region;
@@ -2427,7 +2427,7 @@ operation_could_trap_helper_p (enum tree_code op,
       if (honor_snans || honor_trapv)
 	return true;
       if (fp_operation)
-	return flag_trapping_math;
+	return GCC_OPTION (flag_trapping_math);
       if (!TREE_CONSTANT (divisor) || integer_zerop (divisor))
         return true;
       return false;
@@ -2468,7 +2468,7 @@ operation_could_trap_helper_p (enum tree_code op,
     case MINUS_EXPR:
     case MULT_EXPR:
       /* Any floating arithmetic may trap.  */
-      if (fp_operation && flag_trapping_math)
+      if (fp_operation && GCC_OPTION (flag_trapping_math))
 	return true;
       if (honor_trapv)
 	return true;
@@ -2481,7 +2481,7 @@ operation_could_trap_helper_p (enum tree_code op,
 
     default:
       /* Any floating arithmetic may trap.  */
-      if (fp_operation && flag_trapping_math)
+      if (fp_operation && GCC_OPTION (flag_trapping_math))
 	return true;
 
       *handled = false;
@@ -2498,9 +2498,9 @@ bool
 operation_could_trap_p (enum tree_code op, bool fp_operation, bool honor_trapv,
 			tree divisor)
 {
-  bool honor_nans = (fp_operation && flag_trapping_math
-		     && !flag_finite_math_only);
-  bool honor_snans = fp_operation && flag_signaling_nans != 0;
+  bool honor_nans = (fp_operation && GCC_OPTION (flag_trapping_math)
+		     && !GCC_OPTION (flag_finite_math_only));
+  bool honor_snans = fp_operation && GCC_OPTION (flag_signaling_nans) != 0;
   bool handled;
 
   if (TREE_CODE_CLASS (op) != tcc_comparison
@@ -2748,8 +2748,8 @@ stmt_could_throw_1_p (gimple stmt)
       fp_operation = FLOAT_TYPE_P (t);
       if (fp_operation)
 	{
-	  honor_nans = flag_trapping_math && !flag_finite_math_only;
-	  honor_snans = flag_signaling_nans != 0;
+	  honor_nans = GCC_OPTION (flag_trapping_math) && !GCC_OPTION (flag_finite_math_only);
+	  honor_snans = GCC_OPTION (flag_signaling_nans) != 0;
 	}
       else if (INTEGRAL_TYPE_P (t) && TYPE_OVERFLOW_TRAPS (t))
 	honor_trapv = true;
@@ -2778,7 +2778,7 @@ stmt_could_throw_1_p (gimple stmt)
 bool
 stmt_could_throw_p (gimple stmt)
 {
-  if (!flag_exceptions)
+  if (!GCC_OPTION (flag_exceptions))
     return false;
 
   /* The only statements that can throw an exception are assignments,
@@ -2813,7 +2813,7 @@ stmt_could_throw_p (gimple stmt)
 bool
 tree_could_throw_p (tree t)
 {
-  if (!flag_exceptions)
+  if (!GCC_OPTION (flag_exceptions))
     return false;
   if (TREE_CODE (t) == MODIFY_EXPR)
     {
@@ -3119,7 +3119,7 @@ refactor_eh (void)
 static bool
 gate_refactor_eh (void)
 {
-  return flag_exceptions != 0;
+  return GCC_OPTION (flag_exceptions) != 0;
 }
 
 namespace {
@@ -3346,7 +3346,7 @@ execute_lower_resx (void)
 static bool
 gate_lower_resx (void)
 {
-  return flag_exceptions != 0;
+  return GCC_OPTION (flag_exceptions) != 0;
 }
 
 namespace {
@@ -4561,7 +4561,7 @@ execute_cleanup_eh_1 (void)
     {
       bool changed = false;
 
-      if (optimize)
+      if (GCC_OPTION (optimize))
 	changed |= unsplit_all_eh ();
       changed |= cleanup_all_empty_eh ();
 
diff --git a/gcc/tree-if-conv.c b/gcc/tree-if-conv.c
index 0dc340f..19013d3 100644
--- a/gcc/tree-if-conv.c
+++ b/gcc/tree-if-conv.c
@@ -501,7 +501,7 @@ if_convertible_phi_p (struct loop *loop, basic_block bb, gimple phi,
       return false;
     }
 
-  if (flag_tree_loop_if_convert_stores || any_mask_load_store)
+  if (GCC_OPTION (flag_tree_loop_if_convert_stores) || any_mask_load_store)
     return true;
 
   /* When the flag_tree_loop_if_convert_stores is not set, check
@@ -728,7 +728,7 @@ ifcvt_can_use_mask_load_store (gimple stmt)
   basic_block bb = gimple_bb (stmt);
   bool is_load;
 
-  if (!(flag_tree_loop_vectorize || bb->loop_father->force_vect)
+  if (!(GCC_OPTION (flag_tree_loop_vectorize) || bb->loop_father->force_vect)
       || bb->loop_father->dont_vectorize
       || !gimple_assign_single_p (stmt)
       || gimple_has_volatile_ops (stmt))
@@ -808,7 +808,7 @@ if_convertible_gimple_assign_stmt_p (gimple stmt,
      we can perform loop versioning.  */
   gimple_set_plf (stmt, GF_PLF_2, false);
 
-  if (flag_tree_loop_if_convert_stores)
+  if (GCC_OPTION (flag_tree_loop_if_convert_stores))
     {
       if (ifcvt_could_trap_p (stmt, refs))
 	{
@@ -1216,7 +1216,7 @@ if_convertible_loop_p_1 (struct loop *loop,
 	  }
     }
 
-  if (flag_tree_loop_if_convert_stores)
+  if (GCC_OPTION (flag_tree_loop_if_convert_stores))
     {
       data_reference_p dr;
 
@@ -1242,7 +1242,7 @@ if_convertible_loop_p_1 (struct loop *loop,
 	    return false;
     }
 
-  if (flag_tree_loop_if_convert_stores)
+  if (GCC_OPTION (flag_tree_loop_if_convert_stores))
     for (i = 0; i < loop->num_nodes; i++)
       free_bb_predicate (ifc_bbs[i]);
 
@@ -1318,7 +1318,7 @@ if_convertible_loop_p (struct loop *loop, bool *any_mask_load_store)
   res = if_convertible_loop_p_1 (loop, &loop_nest, &refs, &ddrs,
 				 any_mask_load_store);
 
-  if (flag_tree_loop_if_convert_stores)
+  if (GCC_OPTION (flag_tree_loop_if_convert_stores))
     {
       data_reference_p dr;
       unsigned int i;
@@ -1523,7 +1523,7 @@ insert_gimplified_predicates (loop_p loop, bool any_mask_load_store)
       stmts = bb_predicate_gimplified_stmts (bb);
       if (stmts)
 	{
-	  if (flag_tree_loop_if_convert_stores
+	  if (GCC_OPTION (flag_tree_loop_if_convert_stores)
 	      || any_mask_load_store)
 	    {
 	      /* Insert the predicate of the BB just after the label,
@@ -1808,7 +1808,7 @@ combine_blocks (struct loop *loop, bool any_mask_load_store)
   insert_gimplified_predicates (loop, any_mask_load_store);
   predicate_all_scalar_phis (loop);
 
-  if (flag_tree_loop_if_convert_stores || any_mask_load_store)
+  if (GCC_OPTION (flag_tree_loop_if_convert_stores) || any_mask_load_store)
     predicate_mem_writes (loop);
 
   /* Merge basic blocks: first remove all the edges in the loop,
@@ -1950,7 +1950,7 @@ tree_if_conversion (struct loop *loop)
     goto cleanup;
 
   if (any_mask_load_store
-      && ((!flag_tree_loop_vectorize && !loop->force_vect)
+      && ((!GCC_OPTION (flag_tree_loop_vectorize) && !loop->force_vect)
 	  || loop->dont_vectorize))
     goto cleanup;
 
@@ -1963,7 +1963,7 @@ tree_if_conversion (struct loop *loop)
   combine_blocks (loop, any_mask_load_store);
 
   todo |= TODO_cleanup_cfg;
-  if (flag_tree_loop_if_convert_stores || any_mask_load_store)
+  if (GCC_OPTION (flag_tree_loop_if_convert_stores) || any_mask_load_store)
     {
       mark_virtual_operands_for_renaming (cfun);
       todo |= TODO_update_ssa_only_virtuals;
@@ -1996,9 +1996,9 @@ main_tree_if_conversion (void)
     return 0;
 
   FOR_EACH_LOOP (loop, 0)
-    if (flag_tree_loop_if_convert == 1
-	|| flag_tree_loop_if_convert_stores == 1
-	|| ((flag_tree_loop_vectorize || loop->force_vect)
+    if (GCC_OPTION (flag_tree_loop_if_convert) == 1
+	|| GCC_OPTION (flag_tree_loop_if_convert_stores) == 1
+	|| ((GCC_OPTION (flag_tree_loop_vectorize) || loop->force_vect)
 	    && !loop->dont_vectorize))
       todo |= tree_if_conversion (loop);
 
@@ -2018,10 +2018,10 @@ main_tree_if_conversion (void)
 static bool
 gate_tree_if_conversion (void)
 {
-  return (((flag_tree_loop_vectorize || cfun->has_force_vect_loops)
-	   && flag_tree_loop_if_convert != 0)
-	  || flag_tree_loop_if_convert == 1
-	  || flag_tree_loop_if_convert_stores == 1);
+  return (((GCC_OPTION (flag_tree_loop_vectorize) || cfun->has_force_vect_loops)
+	   && GCC_OPTION (flag_tree_loop_if_convert) != 0)
+	  || GCC_OPTION (flag_tree_loop_if_convert) == 1
+	  || GCC_OPTION (flag_tree_loop_if_convert_stores) == 1);
 }
 
 namespace {
diff --git a/gcc/tree-inline.c b/gcc/tree-inline.c
index fc83097..1b15e74 100644
--- a/gcc/tree-inline.c
+++ b/gcc/tree-inline.c
@@ -570,7 +570,7 @@ remap_decls (tree decls, vec<tree, va_gc> **nonlocalized_list,
 	  if (TREE_CODE (old_var) == VAR_DECL
 	      && ! DECL_EXTERNAL (old_var))
 	    add_local_decl (cfun, old_var);
-	  if ((!optimize || debug_info_level > DINFO_LEVEL_TERSE)
+	  if ((!GCC_OPTION (optimize) || GCC_OPTION (debug_info_level) > DINFO_LEVEL_TERSE)
 	      && !DECL_IGNORED_P (old_var)
 	      && nonlocalized_list)
 	    vec_safe_push (*nonlocalized_list, old_var);
@@ -588,7 +588,7 @@ remap_decls (tree decls, vec<tree, va_gc> **nonlocalized_list,
 	;
       else if (!new_var)
         {
-	  if ((!optimize || debug_info_level > DINFO_LEVEL_TERSE)
+	  if ((!GCC_OPTION (optimize) || GCC_OPTION (debug_info_level) > DINFO_LEVEL_TERSE)
 	      && !DECL_IGNORED_P (old_var)
 	      && nonlocalized_list)
 	    vec_safe_push (*nonlocalized_list, old_var);
@@ -2935,7 +2935,7 @@ setup_one_parameter (copy_body_data *id, tree p, tree value, tree fn,
      This is important for builtin_constant_p and other construct requiring
      constant argument to be visible in inlined function body.  */
   if (gimple_in_ssa_p (cfun) && rhs && def && is_gimple_reg (p)
-      && (optimize
+      && (GCC_OPTION (optimize)
           || (TREE_READONLY (p)
 	      && is_gimple_min_invariant (rhs)))
       && (TREE_CODE (rhs) == SSA_NAME
@@ -2948,7 +2948,7 @@ setup_one_parameter (copy_body_data *id, tree p, tree value, tree fn,
 
   /* If the value of argument is never used, don't care about initializing
      it.  */
-  if (optimize && gimple_in_ssa_p (cfun) && !def && is_gimple_reg (p))
+  if (GCC_OPTION (optimize) && gimple_in_ssa_p (cfun) && !def && is_gimple_reg (p))
     {
       gcc_assert (!value || !TREE_SIDE_EFFECTS (value));
       return insert_init_debug_bind (id, bb, var, rhs, NULL);
@@ -2978,7 +2978,7 @@ setup_one_parameter (copy_body_data *id, tree p, tree value, tree fn,
 	      SSA_NAME_IS_DEFAULT_DEF (def) = 0;
 	      set_ssa_default_def (cfun, var, NULL);
 	    }
-	  else if (!optimize)
+	  else if (!GCC_OPTION (optimize))
 	    {
 	      def = make_ssa_name (var, NULL);
 	      init_stmt = gimple_build_assign (def, rhs);
@@ -3522,14 +3522,14 @@ tree_inlinable_function_p (tree fn)
     return false;
 
   /* We only warn for functions declared `inline' by the user.  */
-  do_warning = (warn_inline
+  do_warning = (GCC_OPTION (warn_inline)
 		&& DECL_DECLARED_INLINE_P (fn)
 		&& !DECL_NO_INLINE_WARNING_P (fn)
 		&& !DECL_IN_SYSTEM_HEADER (fn));
 
   always_inline = lookup_attribute ("always_inline", DECL_ATTRIBUTES (fn));
 
-  if (flag_no_inline
+  if (GCC_OPTION (flag_no_inline)
       && always_inline == NULL)
     {
       if (do_warning)
@@ -3591,7 +3591,7 @@ estimate_move_cost (tree type)
 
   size = int_size_in_bytes (type);
 
-  if (size < 0 || size > MOVE_MAX_PIECES * MOVE_RATIO (!optimize_size))
+  if (size < 0 || size > MOVE_MAX_PIECES * MOVE_RATIO (!GCC_OPTION (optimize_size)))
     /* Cost of a memcpy call, 3 arguments and the call.  */
     return 4;
   else
@@ -4142,16 +4142,16 @@ expand_call_inline (basic_block bb, gimple stmt, copy_body_data *id)
 	  /* During early inline pass, report only when optimization is
 	     not turned on.  */
 	  && (cgraph_global_info_ready
-	      || !optimize
+	      || !GCC_OPTION (optimize)
 	      || cgraph_inline_failed_type (reason) == CIF_FINAL_ERROR)
 	  /* PR 20090218-1_0.c. Body can be provided by another module. */
-	  && (reason != CIF_BODY_NOT_AVAILABLE || !flag_generate_lto))
+	  && (reason != CIF_BODY_NOT_AVAILABLE || !GCC_OPTION (flag_generate_lto)))
 	{
 	  error ("inlining failed in call to always_inline %q+F: %s", fn,
 		 cgraph_inline_failed_string (reason));
 	  error ("called from here");
 	}
-      else if (warn_inline
+      else if (GCC_OPTION (warn_inline)
 	       && DECL_DECLARED_INLINE_P (fn)
 	       && !DECL_NO_INLINE_WARNING_P (fn)
 	       && !DECL_IN_SYSTEM_HEADER (fn)
diff --git a/gcc/tree-loop-distribution.c b/gcc/tree-loop-distribution.c
index 9db92db..bee6aa3 100644
--- a/gcc/tree-loop-distribution.c
+++ b/gcc/tree-loop-distribution.c
@@ -1016,7 +1016,7 @@ classify_partition (loop_p loop, struct graph *rdg, partition_t partition)
 
   /* Perform general partition disqualification for builtins.  */
   if (volatiles_p
-      || !flag_tree_loop_distribute_patterns)
+      || !GCC_OPTION (flag_tree_loop_distribute_patterns))
     return;
 
   /* Detect memset and memcpy.  */
@@ -1448,7 +1448,7 @@ distribute_loop (struct loop *loop, vec<gimple> stmts,
 
   /* If we are only distributing patterns but did not detect any,
      simply bail out.  */
-  if (!flag_tree_loop_distribution
+  if (!GCC_OPTION (flag_tree_loop_distribution)
       && !any_builtin)
     {
       nbp = 0;
@@ -1460,7 +1460,7 @@ distribute_loop (struct loop *loop, vec<gimple> stmts,
      a loop into pieces, separated by builtin calls.  That is, we
      only want no or a single loop body remaining.  */
   partition_t into;
-  if (!flag_tree_loop_distribution)
+  if (!GCC_OPTION (flag_tree_loop_distribution))
     {
       for (i = 0; partitions.iterate (i, &into); ++i)
 	if (!partition_builtin_p (into))
@@ -1793,8 +1793,8 @@ out:
 static bool
 gate_tree_loop_distribution (void)
 {
-  return flag_tree_loop_distribution
-    || flag_tree_loop_distribute_patterns;
+  return GCC_OPTION (flag_tree_loop_distribution)
+    || GCC_OPTION (flag_tree_loop_distribute_patterns);
 }
 
 namespace {
diff --git a/gcc/tree-nested.c b/gcc/tree-nested.c
index df6923f..d048163 100644
--- a/gcc/tree-nested.c
+++ b/gcc/tree-nested.c
@@ -892,7 +892,7 @@ get_nonlocal_debug_decl (struct nesting_info *info, tree decl)
   DECL_CHAIN (new_decl) = info->debug_var_chain;
   info->debug_var_chain = new_decl;
 
-  if (!optimize
+  if (!GCC_OPTION (optimize)
       && info->context != target_context
       && variably_modified_type_p (TREE_TYPE (decl), NULL))
     note_nonlocal_vla_type (info, TREE_TYPE (decl));
@@ -1328,7 +1328,7 @@ convert_nonlocal_reference_stmt (gimple_stmt_iterator *gsi, bool *handled_ops_p,
       break;
 
     case GIMPLE_BIND:
-      if (!optimize && gimple_bind_block (stmt))
+      if (!GCC_OPTION (optimize) && gimple_bind_block (stmt))
 	note_nonlocal_block_vlas (info, gimple_bind_block (stmt));
 
       for (tree var = gimple_bind_vars (stmt); var; var = DECL_CHAIN (var))
@@ -2428,12 +2428,12 @@ finalize_nesting_tree_1 (struct nesting_info *root)
     {
       /* In some cases the frame type will trigger the -Wpadded warning.
 	 This is not helpful; suppress it. */
-      int save_warn_padded = warn_padded;
+      int save_warn_padded = GCC_OPTION (warn_padded);
       tree *adjust;
 
-      warn_padded = 0;
+      GCC_OPTION (warn_padded) = 0;
       layout_type (root->frame_type);
-      warn_padded = save_warn_padded;
+      GCC_OPTION (warn_padded) = save_warn_padded;
       layout_decl (root->frame_decl, 0);
 
       /* Remove root->frame_decl from root->new_local_var_chain, so
diff --git a/gcc/tree-nrv.c b/gcc/tree-nrv.c
index b443388..56641ed 100644
--- a/gcc/tree-nrv.c
+++ b/gcc/tree-nrv.c
@@ -275,7 +275,7 @@ tree_nrv (void)
 static bool
 gate_pass_return_slot (void)
 {
-  return optimize > 0;
+  return GCC_OPTION (optimize) > 0;
 }
 
 namespace {
diff --git a/gcc/tree-outof-ssa.c b/gcc/tree-outof-ssa.c
index d5a635b..7029ecf 100644
--- a/gcc/tree-outof-ssa.c
+++ b/gcc/tree-outof-ssa.c
@@ -87,7 +87,7 @@ ssa_is_replaceable_p (gimple stmt)
     return false;
 
   /* Float expressions must go through memory if float-store is on.  */
-  if (flag_float_store
+  if (GCC_OPTION (flag_float_store)
       && FLOAT_TYPE_P (gimple_expr_type (stmt)))
     return false;
 
@@ -1217,7 +1217,7 @@ rewrite_out_of_ssa (struct ssaexpand *sa)
   if (dump_file && (dump_flags & TDF_DETAILS))
     gimple_dump_cfg (dump_file, dump_flags & ~TDF_DETAILS);
 
-  remove_ssa_form (flag_tree_ter, sa);
+  remove_ssa_form (GCC_OPTION (flag_tree_ter), sa);
 
   if (dump_file && (dump_flags & TDF_DETAILS))
     gimple_dump_cfg (dump_file, dump_flags & ~TDF_DETAILS);
diff --git a/gcc/tree-parloops.c b/gcc/tree-parloops.c
index 47179a9..9c90a1a 100644
--- a/gcc/tree-parloops.c
+++ b/gcc/tree-parloops.c
@@ -2143,7 +2143,7 @@ try_create_reduction_list (loop_p loop,
 bool
 parallelize_loops (void)
 {
-  unsigned n_threads = flag_tree_parallelize_loops;
+  unsigned n_threads = GCC_OPTION (flag_tree_parallelize_loops);
   bool changed = false;
   struct loop *loop;
   struct tree_niter_desc niter_desc;
@@ -2176,7 +2176,7 @@ parallelize_loops (void)
 
       /* If we use autopar in graphite pass, we use its marked dependency
       checking results.  */
-      if (flag_loop_parallelize_all && !loop->can_be_parallel)
+      if (GCC_OPTION (flag_loop_parallelize_all) && !loop->can_be_parallel)
       {
         if (dump_file && (dump_flags & TDF_DETAILS))
 	   fprintf (dump_file, "loop is not parallel according to graphite\n");
@@ -2205,7 +2205,7 @@ parallelize_loops (void)
 	estimated = max_stmt_executions_int (loop);
       /* FIXME: Bypass this check as graphite doesn't update the
 	 count and frequency correctly now.  */
-      if (!flag_loop_parallelize_all
+      if (!GCC_OPTION (flag_loop_parallelize_all)
 	  && ((estimated != -1
 	       && estimated <= (HOST_WIDE_INT) n_threads * MIN_PER_THREAD)
 	      /* Do not bother with loops in cold areas.  */
@@ -2218,7 +2218,7 @@ parallelize_loops (void)
       if (!try_create_reduction_list (loop, reduction_list))
 	continue;
 
-      if (!flag_loop_parallelize_all
+      if (!GCC_OPTION (flag_loop_parallelize_all)
 	  && !loop_parallel_p (loop, &parloop_obstack))
 	continue;
 
@@ -2256,7 +2256,7 @@ parallelize_loops (void)
 static bool
 gate_tree_parallelize_loops (void)
 {
-  return flag_tree_parallelize_loops > 1;
+  return GCC_OPTION (flag_tree_parallelize_loops) > 1;
 }
 
 static unsigned
diff --git a/gcc/tree-predcom.c b/gcc/tree-predcom.c
index 730bad4..5d968fb 100644
--- a/gcc/tree-predcom.c
+++ b/gcc/tree-predcom.c
@@ -1976,7 +1976,7 @@ static bool
 may_reassociate_p (tree type, enum tree_code code)
 {
   if (FLOAT_TYPE_P (type)
-      && !flag_unsafe_math_optimizations)
+      && !GCC_OPTION (flag_unsafe_math_optimizations))
     return false;
 
   return (commutative_tree_code (code)
@@ -2576,7 +2576,7 @@ run_tree_predictive_commoning (void)
 static bool
 gate_tree_predictive_commoning (void)
 {
-  return flag_predictive_commoning != 0;
+  return GCC_OPTION (flag_predictive_commoning) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-profile.c b/gcc/tree-profile.c
index 02e9ff2..b960107 100644
--- a/gcc/tree-profile.c
+++ b/gcc/tree-profile.c
@@ -86,7 +86,7 @@ init_ic_make_global_vars (void)
   ptr_void = build_pointer_type (void_type_node);
 
   /* Workaround for binutils bug 14342.  Once it is fixed, remove lto path.  */
-  if (flag_lto)
+  if (GCC_OPTION (flag_lto))
     {
       ic_void_ptr_var
 	= build_decl (UNKNOWN_LOCATION, VAR_DECL,
@@ -117,7 +117,7 @@ init_ic_make_global_vars (void)
 
   gcov_type_ptr = build_pointer_type (get_gcov_type ());
   /* Workaround for binutils bug 14342.  Once it is fixed, remove lto path.  */
-  if (flag_lto)
+  if (GCC_OPTION (flag_lto))
     {
       ic_gcov_type_ptr_var
 	= build_decl (UNKNOWN_LOCATION, VAR_DECL,
@@ -207,7 +207,7 @@ gimple_init_edge_profiler (void)
       init_ic_make_global_vars ();
 
       /* Workaround for binutils bug 14342.  Once it is fixed, remove lto path.  */
-      if (flag_lto)
+      if (GCC_OPTION (flag_lto))
         {
 	  /* void (*) (gcov_type, void *)  */
 	  ic_profiler_fn_type
@@ -455,7 +455,7 @@ gimple_gen_ic_func_profiler (void)
   tree_uid = build_int_cst
 	      (gcov_type_node, cgraph_get_node (current_function_decl)->profile_id);
   /* Workaround for binutils bug 14342.  Once it is fixed, remove lto path.  */
-  if (flag_lto)
+  if (GCC_OPTION (flag_lto))
     {
       tree counter_ptr, ptr_var;
       counter_ptr = force_gimple_operand_gsi (&gsi, ic_gcov_type_ptr_var,
@@ -588,13 +588,13 @@ tree_profiling (void)
 
       branch_prob ();
 
-      if (! flag_branch_probabilities
-	  && flag_profile_values)
+      if (! GCC_OPTION (flag_branch_probabilities)
+	  && GCC_OPTION (flag_profile_values))
 	gimple_gen_ic_func_profiler ();
 
-      if (flag_branch_probabilities
-	  && flag_profile_values
-	  && flag_value_profile_transformations)
+      if (GCC_OPTION (flag_branch_probabilities)
+	  && GCC_OPTION (flag_profile_values)
+	  && GCC_OPTION (flag_value_profile_transformations))
 	gimple_value_profile_transformations ();
 
       /* The above could hose dominator info.  Currently there is
@@ -668,9 +668,9 @@ tree_profiling (void)
 static bool
 gate_tree_profile_ipa (void)
 {
-  return (!in_lto_p
-	  && (flag_branch_probabilities || flag_test_coverage
-	      || profile_arc_flag));
+  return (!GCC_OPTION (in_lto_p)
+	  && (GCC_OPTION (flag_branch_probabilities) || GCC_OPTION (flag_test_coverage)
+	      || GCC_OPTION (profile_arc_flag)));
 }
 
 namespace {
